 /*
 * This file is an example of an HDF5 filter plugin. 
 */

#include <stdio.h>
#include "H5PLextern.h"

// Filter ID NOT registered with the HDF Group
#define H5Z_FILTER_CAT 32123

static size_t H5Z_filter_cat(unsigned flags, size_t cd_nelmts,
                    const unsigned cd_values[], size_t nbytes,
                    size_t *buf_size, void **buf);

const H5Z_class2_t H5Z_CAT[1] = {{
    H5Z_CLASS_T_VERS,              /* H5Z_class_t version */
    (H5Z_filter_t)H5Z_FILTER_CAT,  /* Filter id number */
    1,                             /* encoder_present flag (set to true) */
    1,                             /* decoder_present flag (set to true) */
    "HDF5 cat filter, used for testing",
                                   /* Filter name for debugging */
    NULL,                          /* The "can apply" callback */
    NULL,                          /* The "set local" callback */
    (H5Z_func_t)H5Z_filter_cat,    /* The actual filter function */
}};

H5PL_type_t   H5PLget_plugin_type(void) {
    return H5PL_TYPE_FILTER;
}
const void *H5PLget_plugin_info(void) {
    return H5Z_CAT;
}



size_t H5Z_filter_cat(unsigned flags, size_t cd_nelmts,
                    const unsigned cd_values[], size_t nbytes,
                    size_t *buf_size, void **buf)
{
    if(!(flags & H5Z_FLAG_REVERSE))
        printf("H5Zcat compressing\n");
    else
        printf("H5Zcat decompressing\n");

    printf("%zd cd_values:\n", cd_nelmts);
    for (size_t i = 0; i < cd_nelmts; ++i)
        printf("cd_values[%zd] = %u\n", i, cd_values[i]);

    return *buf_size;
}
